Subject: RE: bug#49278: [External] : bug#49278: 28.0.50; Lisp Mode is for Common Lisp

From: Drew Adams <[email-masked]>
Date: Tue, 28 Sep 2021 02:17:48 +0000

> > It matters, I think, if the mode is called "Lisp mode".
> 
> Yes, it's true.  The name is unfortunate.  There are many Lisps,
> but "Lisp mode" is designed to work with only one of them, Common
> Lisp.
> 
> Renaming the mode to clarify an option IMO.  Maybe, if it has no
> impacts.  _Then_ would you agree to "Common Lisp mode is for Common Lisp"?

Yes, but you really don't need my agreement on
any of this.  I wasn't even aware that lisp-mode
is only suitable for Common Lisp mode.  I think
you'll find that I never claimed that lisp-mode
is suitable for more than Common Lisp.  I asked
if folks were sure that it isn't.

The last time I used lisp-mode itself was probably
back in the 80s and 90s, when coding Common Lisp.

And lisp-mode was apparently always described
(perhaps inappropriately even from the beginning?)
as "for Lisps other than GNU Emacs Lisp".  I guess,
not having used it much recently, I just assumed
that description was apt at some level.

I don't really care how y'all resolve this.  I do
think that a misleading mode name is just about as
important as a misleading description - maybe more
so.  People see the mode name much more often than
they read a mode description.

A question that occurs to me, but I have no reason
to argue about it, is whether it would make sense
to move the specifically CL stuff from lisp-mode
to a cl-mode, which would inherit from a neutral
lisp-mode.  Perhaps that neutral code would serve
as ancestor also of the modes for Closure and
Scheme?  No idea whether any such factoring would
make sense.  Maybe there's so little in common
that a real (neutral) lisp-mode would make no sense.

Another question, in light of your endeavor: what
about lisp-interaction-mode?  Is that suitable for
more lisps than Elisp?  It has emacs-lisp-mode as
a parent, but it's called "lisp" interaction mode.
Is it suitable for Closure and Scheme?  If not,
should it too perhaps be renamed and redescribed?
(Part of its description is "Like Lisp mode
except...".)

Back in Emacs 20, lisp-interaction-mode was defined
in library lisp-mode.el, BTW.  Now it's defined in
elisp-mode.el.

(You might guess that I also don't use
lisp-interaction-mode.  I typically change the mode
of `*scratch*' to emacs-lisp-mode.)

> Everybody that codes Common Lisp knows it by 'lisp-mode' and there
> are many tools that use that name. Maybe we could make an alias?

There are various ways to rename.  A priori, I
don't care whether or how it's renamed.  I do
think that if lisp-mode is really common-lisp-mode,
and its name is throwing people off, then renaming
would make sense - other things being equal.  It's
those other things that might not all be so equal
that you'll likely want to weight.

Similarly, if lisp-interaction-mode is really
elisp-interaction-mode.  (I don't say that it is;
I don't know, and I don't care.)

> Anyway, just _because_ it happens to be called Lisp Mode, erroneously,
> doesn't make it suitable for more Lisps magically.

No, of course not.  Did something give you the
impression that I would think that?

 - Real Michael Jordan